-- Globals Section
MyAddon_UpdateInterval = .1; -- How often the OnUpdate code will run (in seconds)
zpetspec = ""
allframesshow = true

-- Functions Section
function MyAddon_OnUpdate(self, elapsed)
GetSpec()
  self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	

  if (self.TimeSinceLastUpdate > MyAddon_UpdateInterval) then
    --
    -- Insert your OnUpdate code here
	--print("test")
    --
	--
	--print (zpetspec)
	if allframesshow == true then
		if zpetspec == "Demonology" then
		--print (zpetspec)
		DemoClassCreate()
		end
	
		UpdateZUI()
		else
		HideFrames()
	end
		
    self.TimeSinceLastUpdate = 0;
  end
end



-- Global Variables --
playerguid=nil
impcount=0
deimpcount=0
totalimpcount=0
wildimpvalue=0
dreadcount=0
dedreadcount=0
totaldreadcount=0
thalkielstota=0
--beholdercount=0
--debeholdercount=0
thalkielstotalvalue=0
totalvalueofimplosion=0
totalimplosionloss=0

-- Pet Tables --
emptytimetable={}
imptimetable={}
impdurtable={}
deimptimetable={}
deimpdurtable={}
impcasttime={}
deimpcasttime={}
dreadtimetable={}
dedreadtimetable={}
--beholdertimetable={}
--debeholdertimetable={}

-- Doomguard variables
doomguardde = 0
doomguardcount = 0
doomguardduration = 0
doomguarddeduration = 0
doomguardappliedduration = 12
doomguardspawned = 0
doomguarddeapplied = 0

-- Infernal variables
infernalde = 0
infernalcount = 0
infernalspawned = 0
infernaldeapplied = 0
infernalduration = 0
infernaldeduration = 0
infernalappliedduration = 12

-- service variables
servicename="Felguard"
servicede = 0
servicecount = 0
servicespawned = 0
servicedeapplied = 0
serviceduration = 0
servicededuration = 0
serviceappliedduration = 12

-- darkglare variables
darkglarede = 0
darkglarecount = 0
darkglarespawned = 0
darkglaredeapplied = 0
darkglareduration = 0
darkglarededuration = 0
darkglareappliedduration = 12

-- HitCount tables
demonwrathhits={}
implosionhits={}
felstormhits={}
legionstrikehits={}
HitCountDemonwrath=0
HitCountImplosion=0
HitCountFelstorm=0
HitCountLegionstrike=0

-- CooldownStart
CallDreadStalker=0
SummonBeholder=0
PetFelstorm=0
CosumptionCD=0
ServiceCD=0

-- Artifact Modifiers --
if zpetsartifactpower1==nil then
 zpetsartifactpower1=0
end
if zpetsartifactpower2==nil then
 zpetsartifactpower2=0
end
local infernalfurnace = .1
local ifdamagemod = ((infernalfurnace*zpetsartifactpower1)+1)
local SPMod = 0

-- Spell and Pet Data --
dehastevalue = 60+SPMod

-- Class Timer Frames --
MyZpetBar1 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar1:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar1:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar2 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar2:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar2:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar3 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar3:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar3:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar4 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar4:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar4:GetStatusBarTexture():SetHorizTile(false)

MyZpetBar5 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar5:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar5:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar6 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar6:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar6:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar7 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar7:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar7:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar8 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar8:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar8:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar9 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar9:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar9:GetStatusBarTexture():SetHorizTile(false)

MyZpetBar10 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar10:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar10:GetStatusBarTexture():SetHorizTile(false)
MyZpetBar11 = CreateFrame("StatusBar", nil, UIParent)
MyZpetBar11:SetStatusBarTexture("Interface\\Addons\\zPets\\Textures\\Flat")
MyZpetBar11:GetStatusBarTexture():SetHorizTile(false)

local MyZpetText1 = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
MyZpetText1:SetPoint("BOTTOMLEFT",MyZpetBar3,"BOTTOMLEFT",0,-2)
--MyZpetText1:SetText("Testtext")
MyZpetText1:SetFont("Fonts\\ARIALN.TTF", 13)

local MyZpetText2 = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
MyZpetText2:SetPoint("BOTTOMLEFT",zPetsHIT,"TOPRIGHT",5,5)
--MyZpetText2:SetText("Testtext")
MyZpetText2:SetFont("Fonts\\ARIALN.TTF", 30)

local MyZpetText3 = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
MyZpetText3:SetPoint("BOTTOMLEFT",zPetsHIT,"TOPRIGHT",5,40)
--MyZpetText3:SetText("Testtext")
MyZpetText3:SetFont("Fonts\\ARIALN.TTF", 30)

local MyZpetText4 = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
MyZpetText4:SetPoint("BOTTOMLEFT",zPetsHIT,"TOPRIGHT",5,75)
--MyZpetText4:SetText("Testtext")
MyZpetText4:SetFont("Fonts\\ARIALN.TTF", 30)

local MyZpetText5 = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
MyZpetText5:SetPoint("BOTTOMLEFT",zPetsHIT,"TOPRIGHT",5,110)
--MyZpetText5:SetText("Testtext")
MyZpetText5:SetFont("Fonts\\ARIALN.TTF", 30)



-- Icon 1 --
ZpetsIcon1 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon1:SetFrameStrata("BACKGROUND")
ZpetsIcon1:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon1:SetHeight(40) -- for your Texture
zt2 = ZpetsIcon1:CreateTexture(nil,"BACKGROUND")
zt2:SetTexture("Interface\\ICONS\\spell_warlock_calldreadstalkers")
SetDesaturation(zt2, nil)
zt2:SetAllPoints(ZpetsIcon1)
ZpetsIcon1.texture = zt2
ZpetsIcon1:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", 79, -1);

MyZpetCDFrame1Start = 0

MyZpetCDFrame1 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
--MyZpetCDFrame1:SetPoint("BOTTOMLEFT",ZpetsIcon1,"BOTTOMLEFT",0,-2)
MyZpetCDFrame1:SetAllPoints(ZpetsIcon1)

local ZpetsIcon1Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon1Text:SetText("2.4")
ZpetsIcon1Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

-- Icon 2 --
ZpetsIcon2 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon2:SetFrameStrata("BACKGROUND")
ZpetsIcon2:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon2:SetHeight(40) -- for your Texture
zt3 = ZpetsIcon2:CreateTexture(nil,"BACKGROUND")
zt3:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
SetDesaturation(zt3, nil)
zt3:SetAllPoints(ZpetsIcon2)
ZpetsIcon2.texture = zt3
ZpetsIcon2:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", 120, -1);

MyZpetCDFrame2 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
MyZpetCDFrame2:SetPoint("BOTTOMLEFT",ZpetsIcon2,"BOTTOMLEFT",0,-2)
MyZpetCDFrame2:SetAllPoints(ZpetsIcon2)

local ZpetsIcon2Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon2Text:SetText("2.4")
ZpetsIcon2Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

-- Icon 3 --
ZpetsIcon3 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon3:SetFrameStrata("BACKGROUND")
ZpetsIcon3:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon3:SetHeight(40) -- for your Texture
zt4 = ZpetsIcon3:CreateTexture(nil,"BACKGROUND")
zt4:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
SetDesaturation(zt4, nil)
zt4:SetAllPoints(ZpetsIcon3)
ZpetsIcon3.texture = zt4
ZpetsIcon3:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", 38, -1);

MyZpetCDFrame3 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
MyZpetCDFrame3:SetPoint("BOTTOMLEFT",ZpetsIcon3,"BOTTOMLEFT",0,-2)
MyZpetCDFrame3:SetAllPoints(ZpetsIcon3)

local ZpetsIcon3Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon3Text:SetText("2.4")
ZpetsIcon3Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

-- Icon 4 --
ZpetsIcon4 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon4:SetFrameStrata("BACKGROUND")
ZpetsIcon4:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon4:SetHeight(40) -- for your Texture
zt5 = ZpetsIcon4:CreateTexture(nil,"BACKGROUND")
zt5:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
SetDesaturation(zt5, nil)
zt5:SetAllPoints(ZpetsIcon4)
ZpetsIcon4.texture = zt5
ZpetsIcon4:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", 161, -1);

MyZpetCDFrame4 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
MyZpetCDFrame4:SetPoint("BOTTOMLEFT",ZpetsIcon4,"BOTTOMLEFT",0,-2)
MyZpetCDFrame4:SetAllPoints(ZpetsIcon4)

local ZpetsIcon4Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon4Text:SetText("2.4")
ZpetsIcon4Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

-- Icon 5 --
ZpetsIcon5 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon5:SetFrameStrata("BACKGROUND")
ZpetsIcon5:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon5:SetHeight(40) -- for your Texture
zt6 = ZpetsIcon5:CreateTexture(nil,"BACKGROUND")
zt6:SetTexture("Interface\\ICONS\\warlock_summon_doomguard")
SetDesaturation(zt6, nil)
zt6:SetAllPoints(ZpetsIcon5)
ZpetsIcon5.texture = zt6
ZpetsIcon5:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", -3, -1);

MyZpetCDFrame5 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
MyZpetCDFrame5:SetPoint("BOTTOMLEFT",ZpetsIcon5,"BOTTOMLEFT",0,-2)
MyZpetCDFrame5:SetAllPoints(ZpetsIcon5)

local ZpetsIcon5Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon5Text:SetText("2.4")
ZpetsIcon5Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

-- Icon 6 --
ZpetsIcon6 = CreateFrame("Frame",nil,UIParent)
ZpetsIcon6:SetFrameStrata("BACKGROUND")
ZpetsIcon6:SetWidth(40) -- Set these to whatever height/width is needed 
ZpetsIcon6:SetHeight(40) -- for your Texture
zt7 = ZpetsIcon6:CreateTexture(nil,"BACKGROUND")
zt7:SetTexture("Interface\\ICONS\\warlock_summon_doomguard")
SetDesaturation(zt7, nil)
zt7:SetAllPoints(ZpetsIcon6)
ZpetsIcon6.texture = zt7
ZpetsIcon6:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", -3, -42);

MyZpetCDFrame6 = CreateFrame("Cooldown", nil, UIParent, "CooldownFrameTemplate")
MyZpetCDFrame6:SetPoint("BOTTOMLEFT",ZpetsIcon6,"BOTTOMLEFT",0,-2)
MyZpetCDFrame6:SetAllPoints(ZpetsIcon6)

local ZpetsIcon6Text = MyZpetBar3:CreateFontString("FontString","OVERLAY","GameTooltipText")
ZpetsIcon6Text:SetText("2.4")
ZpetsIcon6Text:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")

	ZpetsIcon1:Hide()
	ZpetsIcon2:Hide()
	ZpetsIcon3:Hide()
	ZpetsIcon4:Hide()
	ZpetsIcon5:Hide()
	ZpetsIcon6:Hide()

-- zPet Background --
zPetBackground = CreateFrame("Frame",nil,UIParent)
zPetBackground:SetFrameStrata("BACKGROUND")
zPetBackground:SetWidth(218) -- Set these to whatever height/width is needed 
zPetBackground:SetHeight(50) -- for your Texture
zt = zPetBackground:CreateTexture(nil,"BACKGROUND")
zt:SetTexture("Interface\\dialogframe\\ui-dialogbox-background-dark")
zt:SetAllPoints(zPetBackground)
zPetBackground.texture = zt



local backdrop = {
  -- path to the background texture
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",  
  -- path to the border texture
  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 32,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 11,
    right = 12,
    top = 12,
    bottom = 11
  }
}



-- register slash commands
impframelocked=false
SLASH_ZPETS1 = '/zpets'
function handler(msg, editbox)
	if msg == '' then
	DEFAULT_CHAT_FRAME:AddMessage("zPets Options:")
	DEFAULT_CHAT_FRAME:AddMessage("zPets lock | unlock")
	DEFAULT_CHAT_FRAME:AddMessage("zPets show | hide")
	DEFAULT_CHAT_FRAME:AddMessage("To set your current Infernal Furnace trait level use the following:")
	DEFAULT_CHAT_FRAME:AddMessage("zPets IF 0-6")
	DEFAULT_CHAT_FRAME:AddMessage("To set your current Summoner's Prowess trait level use the following:")
	DEFAULT_CHAT_FRAME:AddMessage("zPets SP 0-6")
	DEFAULT_CHAT_FRAME:AddMessage("To reset the Implosion loss calculator use the following:")
	DEFAULT_CHAT_FRAME:AddMessage("zPets Reset")
	end
  if msg == 'hide' then
    allframesshow = false
  end
  if msg == 'show' then
    allframesshow = true
  end
  if msg == 'unlock' then
  DEFAULT_CHAT_FRAME:AddMessage("zPets Unlocked")
  zpetsframeshow=true
  zPetsGUI:Show()
  end
  if msg == 'lock' then
  DEFAULT_CHAT_FRAME:AddMessage("zPets Locked")
  zpetsframeshow=false
  zPetsGUI:Hide()
  end
  if msg == 'IF 0' then
  zpetsartifactpower1 = 0
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 0/3")
  end
  if msg == 'IF 1' then
  zpetsartifactpower1 = 1
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 1/3")
  end
  if msg == 'IF 2' then
  zpetsartifactpower1 = 2
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 2/3")
  end
  if msg == 'IF 3' then
  zpetsartifactpower1 = 3
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 3/3")
  end
  if msg == 'IF 4' then
  zpetsartifactpower1 = 4
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 4/3")
  end
  if msg == 'IF 5' then
  zpetsartifactpower1 = 5
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 5/3")
  end
  if msg == 'IF 6' then
  zpetsartifactpower1 = 6
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace set to 6/3")
  end
  if msg == 'IF' then
  DEFAULT_CHAT_FRAME:AddMessage("zPets Infernal Furnace is currently set to "..zpetsartifactpower1.."/3")
  end
  if msg == 'SP 0' then
  zpetsartifactpower2 = 0
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 0/3")
  end
  if msg == 'SP 1' then
  zpetsartifactpower2 = 1
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 1/3")
  end
  if msg == 'SP 2' then
  zpetsartifactpower2 = 2
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 2/3")
  end
  if msg == 'SP 3' then
  zpetsartifactpower2 = 3
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 3/3")
  end
  if msg == 'SP 4' then
  zpetsartifactpower2 = 4
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 4/3")
  end
  if msg == 'SP 5' then
  zpetsartifactpower2 = 5
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 5/3")
  end
  if msg == 'SP 6' then
  zpetsartifactpower2 = 6
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess set to 6/3")
  end
  if msg == 'SP' then
  DEFAULT_CHAT_FRAME:AddMessage("zPets Summoner's Prowess is currently set to "..zpetsartifactpower2.."/3")
  end
  if msg == 'Reset' then
  totalimplosionloss=0
  end
end
SlashCmdList["ZPETS"] = handler

-- Rest Total Implosion Loss at start of combat --
local frame, zevents = CreateFrame("Frame"), {};
function zevents:PLAYER_REGEN_DISABLED(...)
	totalimplosionloss = 0
end
function zevents:PLAYER_REGEN_ENABLED(...)
	
end
frame:SetScript("OnEvent", function(self, event, ...)
	zevents[event](self, ...)
end);
for k, v in pairs(zevents) do
	frame:RegisterEvent(k) 
end

function impLoad()
	DEFAULT_CHAT_FRAME:AddMessage("Zinnin's Demo Utilities Loaded.")
	impCountFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	impCountFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function impStartDrag()
	if not impframelocked then
		zPetsGUI:StartMoving()
	end
end

function HitCountDrag()
	if not impframelocked then
		zPetsHIT:StartMoving()
	end
end

function impOnEvent(self, event, ...)
	if zpetsframeshow==false then
		zPetsGUI:Hide()
		zPetsHIT:Hide()
		else
		zPetsGUI:Show()
		zPetsHIT:Show()
	end
	
	-- Set Demonic Empowerment --
	SummonersProwess()
	dehastevalue = 60+SPMod
	
	-- Get current time --
	zpetscomptime = GetTime()
	
	-- Setplayer GUID --
	if(event=="PLAYER_ENTERING_WORLD") then
		playerguid=UnitGUID("player")
	end
	zpetsguid = UnitGUID("pet")
		
	-- Combat Stat Mods --
	zpetsversmod = ((((GetCombatRating(29))/350)/100)+1)
	zpetsversmod2 = (1-(((GetCombatRating(29))/700)/100))
	zpetsmasterymod = ((((GetCombatRating(26))/150)/100)+1.16)
	zpetsspellDmg = GetSpellBonusDamage(6)
	zpetshastemod = ((UnitSpellHaste("player")/100)+1)
	zpetsdehastemod = ((((UnitSpellHaste("player")*((dehastevalue/100)+1))+dehastevalue)/100)+1)
	
	-- Time out all combat tables --	
	TimeOut(imptimetable, 13.2)
	TimeOut(deimptimetable, 13.2)
	TimeOut(dreadtimetable, 13.2)
	TimeOut(dedreadtimetable, 13.2)
	--TimeOut(beholdertimetable, 13.2)
	--TimeOut(debeholdertimetable, 13.2)
	ClearHitCount(demonwrathhits,1,true)
	ClearHitCount(legionstrikehits,5,false)
	ClearHitCount(implosionhits,3,false)
	ClearHitCount(felstormhits,1,false)
	MaintainCooldowns()
	
	-- Combat Log Events and Functions --
	if(event=="COMBAT_LOG_EVENT_UNFILTERED") then
		zpetstimeStamp, zpetscombatevent, zpetshideCaster, zpetssourceGUID, zpetssourceName, zpetssourceFlags, zpetssourceRaidFlags, zpetsdestGUID, zpetsdestName, zpetsdestFlags, zpetsdestRaidFlags, zpetsspellID, zpetsspellName, zpetsspellSchool, zpetsspellSourceGUID, zpetssourceHealth, zpetssourceAP, zpetssourceSP, zpetssourceResourcetype, zpetssourceResourceamount = ...
		SummonTable(imptimetable,"Wild Imp")
		DeathTable(imptimetable,"Wild Imp")
		DeathTable(deimptimetable,"Wild Imp")
		PetCastTable(impcasttime,"Wild Imp",imptimetable)
		SummonTable(dreadtimetable,"Dreadstalker")
		DeathTable(dreadtimetable,"Dreadstalker")
		DeathTable(dedreadtimetable,"Dreadstalker")	
		--SummonTable(beholdertimetable,"Beholder")
		--DeathTable(debeholdertimetable,"Beholder")
		--DeathTable(debeholdertimetable,"Beholder")
		CooldownSummons()		
		DemonicEmpowerment()
		HitCount(felstormhits,"Felstorm",true)
		HitCount(demonwrathhits,"Demonwrath",false)
		HitCount(implosionhits,"Implosion",false)
		HitCount(legionstrikehits,"Legion Strike",true)
		StartPetTimers()
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Implosion") then --This is for if pets are ever cast limted
			--print("Implosion was cast by player")
			totalimplosionloss = math.floor(totalimplosionloss+wildimpvalue)
		end
		-- Cooldowns Tracked
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Call Dreadstalkers") then --This is for if pets are ever cast limted
			CallDreadStalker = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Summon Darkglare") then --This is for if pets are ever cast limted
			SummonBeholder = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==zpetsguid and zpetsspellName=="Felstorm") then --This is for if pets are ever cast limted
			PetFelstorm = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Thal'kiel's Consumption") then --This is for if pets are ever cast limted
			CosumptionCD = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Felguard") then --This is for if pets are ever cast limted
			ServiceCD = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Imp") then --This is for if pets are ever cast limted
			ServiceCD = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Voidwalker") then --This is for if pets are ever cast limted
			ServiceCD = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Felhunter") then --This is for if pets are ever cast limted
			ServiceCD = zpetscomptime
		end
		if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Succubus") then --This is for if pets are ever cast limted
			ServiceCD = zpetscomptime
		end
	end	
	
	MaintainCDProgress()
	
	
	-- Update Global Variables --
	CountPets()
	CountImpCasts()
	ValueWildImps()
	ConsuptionValue()
	ImplosionValue()
	HitCountDemonwrath = entrysum(demonwrathhits)
	HitCountImplosion = entrysum(implosionhits)
	HitCountFelstorm = entrysum(felstormhits)
	HitCountLegionStrike = entrysum(legionstrikehits)
	
		
end

function StartPetTimers()
	if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Doomguard" and zpetssourceGUID==playerguid) then
		--print("test")
		MyZpetCDFrame5:SetCooldown(GetTime(), 26)
		zt6:SetTexture("Interface\\ICONS\\warlock_summon_doomguard")
		
	end
	if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Infernal" and zpetssourceGUID==playerguid) then
		--print("test")
		MyZpetCDFrame5:SetCooldown(GetTime(), 26)
		zt6:SetTexture("Interface\\ICONS\\spell_shadow_summoninfernal")
		
	end
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Felguard") then --This is for if pets are ever cast limted
		MyZpetCDFrame6:SetCooldown(GetTime(), 26)
		zt7:SetTexture("Interface\\ICONS\\spell_shadow_summonfelguard")
	end
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Imp") then --This is for if pets are ever cast limted
		MyZpetCDFrame6:SetCooldown(GetTime(), 26)
		zt7:SetTexture("Interface\\ICONS\\spell_shadow_summonimp")
	end
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Succubus") then --This is for if pets are ever cast limted
		MyZpetCDFrame6:SetCooldown(GetTime(), 26)
		zt7:SetTexture("Interface\\ICONS\\spell_shadow_summonsuccubus")
	end
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Felhunter") then --This is for if pets are ever cast limted
		MyZpetCDFrame6:SetCooldown(GetTime(), 26)
		zt7:SetTexture("Interface\\ICONS\\spell_shadow_summonfelhunter")
	end
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Grimoire: Voidwalker") then --This is for if pets are ever cast limted
		MyZpetCDFrame6:SetCooldown(GetTime(), 26)
		zt7:SetTexture("Interface\\ICONS\\spell_shadow_summonvoidwalker")
	end
end

function UpdateZUI()

		
	-- Update Display
	

	if zpetspec == "Demonology" then
	DemoUI()
	else
	HideFrames()
	end
	--print(currentSpecName)
	--test2 = GetSpellCDProgress("Call Dreadstalkers",15)
	--MyZpetBar1:SetValue(test2)
	
end

function DemoUI()
	-- Position Demo UI --
	MyZpetBar1:SetPoint("BOTTOMLEFT", zPetBackground, "BOTTOMLEFT", 2, 2);
	MyZpetBar2:SetPoint("BOTTOMLEFT", MyZpetBar1, "BOTTOMRIGHT", 2, 0);
	MyZpetBar3:SetPoint("BOTTOMLEFT", MyZpetBar1, "TOPLEFT", 0, 2);
	MyZpetBar4:SetPoint("BOTTOMLEFT", MyZpetBar3, "BOTTOMRIGHT", 2, 0);
	zPetBackground:SetPoint("BOTTOMLEFT", zPetsGUI, "TOPLEFT", 0, 0);
	
	MyZpetBar10:SetPoint("BOTTOMLEFT", MyZpetBar3, "TOPLEFT", 0, 2);
	MyZpetBar11:SetPoint("BOTTOMLEFT", MyZpetBar10, "BOTTOMRIGHT", 2, 0);
	if IsPlayerSpell(205181) then
		MyZpetBar5:SetPoint("BOTTOMLEFT", MyZpetBar10, "TOPLEFT", 0, 2);
		else
		MyZpetBar5:SetPoint("BOTTOMLEFT", MyZpetBar3, "TOPLEFT", 0, 2);
	end	
	MyZpetBar6:SetPoint("BOTTOMLEFT", MyZpetBar5, "BOTTOMRIGHT", 2, 0);
	MyZpetBar7:SetPoint("BOTTOMLEFT", MyZpetBar6, "BOTTOMRIGHT", 2, 0);
	MyZpetBar8:SetPoint("BOTTOMLEFT", MyZpetBar7, "BOTTOMRIGHT", 2, 0);
	MyZpetBar9:SetPoint("BOTTOMLEFT", MyZpetBar8, "BOTTOMRIGHT", 2, 0);
	
	if UnitPower("player" , 7) == 0 then
		MyZpetBar5:Hide()
		MyZpetBar6:Hide()
		MyZpetBar7:Hide()
		MyZpetBar8:Hide()
		MyZpetBar9:Hide()
		elseif UnitPower("player" , 7) == 1 then
		MyZpetBar5:Show()
		MyZpetBar6:Hide()
		MyZpetBar7:Hide()
		MyZpetBar8:Hide()
		MyZpetBar9:Hide()
		elseif UnitPower("player" , 7) == 2 then
		MyZpetBar5:Show()
		MyZpetBar6:Show()
		MyZpetBar7:Hide()
		MyZpetBar8:Hide()
		MyZpetBar9:Hide()
		elseif UnitPower("player" , 7) == 3 then
		MyZpetBar5:Show()
		MyZpetBar6:Show()
		MyZpetBar7:Show()
		MyZpetBar8:Hide()
		MyZpetBar9:Hide()
		elseif UnitPower("player" , 7) == 4 then
		MyZpetBar5:Show()
		MyZpetBar6:Show()
		MyZpetBar7:Show()
		MyZpetBar8:Show()
		MyZpetBar9:Hide()
		elseif UnitPower("player" , 7) == 5 then
		MyZpetBar5:Show()
		MyZpetBar6:Show()
		MyZpetBar7:Show()
		MyZpetBar8:Show()
		MyZpetBar9:Show()
		else
		MyZpetBar5:Hide()
		MyZpetBar6:Hide()
		MyZpetBar7:Hide()
		MyZpetBar8:Hide()
		MyZpetBar9:Hide()
	end
	
	-- Shadowflame Charges --
	if IsPlayerSpell(205181) and GetSpellCharges(205181) == 1 then
		MyZpetBar10:Show()
		MyZpetBar10:SetValue(100)
		MyZpetBar11:Show()
			local SPELL_ID = 205181 -- Set to SpellID of tracked ability
			local chargesCurrent, chargesMax, cdStart, cdDuration = GetSpellCharges(SPELL_ID)
			local CHARGES = function(val) return (val >= 1) end 
			local timeCurrent = GetTime();    
			if (cdStart - cdDuration) <= timeCurrent and timeCurrent <= (cdStart + cdDuration) and CHARGES(chargesCurrent) then 
				local timeleft = ((cdStart+cdDuration)-timeCurrent)
				local results = math.floor((1-(timeleft/cdDuration))*100)
				MyZpetBar11:SetValue(results)
			end
		elseif IsPlayerSpell(205181) and GetSpellCharges(205181) == 2 then
			MyZpetBar10:Show()
			MyZpetBar11:Show()
			MyZpetBar10:SetValue(100)
			MyZpetBar11:SetValue(100)
		elseif IsPlayerSpell(205181) and GetSpellCharges(205181) == 0 then
			MyZpetBar10:Show()
			MyZpetBar11:Hide()
			local SPELL_ID = 205181 -- Set to SpellID of tracked ability
			local chargesCurrent, chargesMax, cdStart, cdDuration = GetSpellCharges(SPELL_ID)
			local CHARGES = function(val) return (val == 0) end 
			local timeCurrent = GetTime();
    		if (cdStart - cdDuration) <= timeCurrent and timeCurrent <= (cdStart + cdDuration) and CHARGES(chargesCurrent) then -- Cooldown active
				local timeleft = ((cdStart+cdDuration)-timeCurrent)
				local results = math.floor((1-(timeleft/cdDuration))*100)
				MyZpetBar10:SetValue(results)
			end
		else
			MyZpetBar10:Hide()
			MyZpetBar11:Hide()
	end	
	
	
	if IsPlayerSpell(205180) then -- Setup Bar 2 Based on Summon Observer talent
		MyZpetBar2:SetValue(GetSpellCDProgress("Summon Darkglare",24,SummonBeholder))	
		else
		MyZpetBar2:SetValue(GetSpellCDProgress("Felstorm",45,PetFelstorm))	
	end
	if IsPlayerSpell(111859) then
		MyZpetBar4:SetValue(GetSpellCDProgress("Grimoire: Imp",90,ServiceCD))
	end
	if IsPlayerSpell(211714) then
		MyZpetBar3:SetValue(GetSpellCDProgress("Thal'kiel's Consumption",60,CosumptionCD))
	end
	MyZpetBar1:SetValue(GetSpellCDProgress("Call Dreadstalkers",15,CallDreadStalker))	
	
	local updatetext = ((GetSpellCDProgress("Thal'kiel's Consumption",60,CosumptionCD)))
	local compare2 = ((UnitHealthMax("player")*.5)/10)
	local compare = ((thalkielstotalvalue /compare2)*100)
	local compare3 = (math.floor(compare))
	local compare4 = (compare3.."%")
	if updatetext >= 75 then
		MyZpetText1:SetText(compare4)
			else
		MyZpetText1:SetText("")
	end
	
	local SpellHitCount = 0
	if HitCountDemonwrath > 0 then
		SpellHitCount = SpellHitCount + 1
	end	
	if HitCountImplosion > 0 then
		SpellHitCount = SpellHitCount + 1
	end	
	if HitCountFelstorm > 0 then
		SpellHitCount = SpellHitCount + 1
	end	
	if HitCountLegionStrike > 1 then
		SpellHitCount = SpellHitCount + 1
	end	
	if SpellHitCount < 2 then
		MyZpetText3:SetText("")
	end
	if SpellHitCount < 3 then
		MyZpetText4:SetText("")
	end
	if SpellHitCount < 4 then
		MyZpetText5:SetText("")
	end
	
	if SpellHitCount == 0 then
			MyZpetText2:SetText("")
		elseif SpellHitCount == 1 and HitCountImplosion > 0 then
			MyZpetText2:SetText("Implosion hit: "..HitCountImplosion.." target")
		elseif SpellHitCount == 1 and HitCountFelstorm > 0 then
			MyZpetText2:SetText("Felstorm hit: "..HitCountFelstorm.." target")
		elseif SpellHitCount == 1 and HitCountLegionStrike > 1 then
			MyZpetText2:SetText("LegionStrike hit: "..HitCountLegionStrike.." target")	
		elseif SpellHitCount == 1 and HitCountDemonwrath > 0 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")	
		elseif SpellHitCount == 2 and HitCountDemonwrath > 1 and HitCountImplosion > 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Implosion hit: "..HitCountImplosion.." target")
		elseif SpellHitCount == 2 and HitCountDemonwrath > 1 and HitCountFelstorm > 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Felstorm hit: "..HitCountFelstorm.." target")
		elseif SpellHitCount == 2 and HitCountDemonwrath > 1 and HitCountLegionStrike > 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 2 and HitCountImplosion > 1 and HitCountFelstorm > 1 then
			MyZpetText2:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText3:SetText("Felstorm hit: "..HitCountFelstorm.." target")
		elseif SpellHitCount == 2 and HitCountImplosion > 1 and HitCountLegionStrike > 1 then
			MyZpetText2:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText3:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 2 and HitCountFelstorm > 1 and HitCountLegionStrike > 1 then
			MyZpetText2:SetText("Felstorm hit: "..HitCountFelstorm.." target")
			MyZpetText3:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 3 and HitCountLegionStrike < 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText4:SetText("Felstorm hit: "..HitCountFelstorm.." target")
		elseif SpellHitCount == 3 and HitCountFelstorm < 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText4:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 3 and HitCountImplosion < 1 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Felstorm hit: "..HitCountFelstorm.." target")
			MyZpetText4:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 3 and HitCountDemonwrath < 1 then
			MyZpetText2:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText3:SetText("Felstorm hit: "..HitCountFelstorm.." target")
			MyZpetText4:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
		elseif SpellHitCount == 4 then
			MyZpetText2:SetText("Demonwrath hit: "..HitCountDemonwrath.." target")
			MyZpetText3:SetText("Implosion hit: "..HitCountImplosion.." target")
			MyZpetText4:SetText("Felstorm hit: "..HitCountFelstorm.." target")
			MyZpetText4:SetText("Legion Strike hit: "..HitCountLegionStrike.." target")
	end
	
	-- Pet Timers --
	--ZpetsIcon1Text:SetPoint("CENTER",MyZpetCDFrame1,"CENTER",0,0)
	--ZpetsIcon1Text:SetText("2.4")
	--if dedreadcount > 0 then
	--	SetDesaturation(zt2, nil)
	--else
	--	SetDesaturation(zt2, 1)
	--end
	--if dreadcount <= 0 and dedreadcount <= 0 then
	--	ZpetsIcon1:Hide()
	--	else
	--	ZpetsIcon1:Show()
	--end
	
	--local i = 1
	--local petIconDur1 = 0
	--while i < 4 do
	--	local haveTotem, tname, startTime, duration, icon = GetTotemInfo(i)
	--	if tname == "Dreadstalkers" then
	---		petIconDur1 = ((duration+1)-(GetTime()-startTime))
	--	end
--i = i + 1
	--end
--if petIconDur1 > 0 then
	--	petIconDur1 = math.floor(petIconDur1)
	--	else
	--	petIconDur1 = 0
	--end
	--if dreadcount <= 0 and dedreadcount <= 0 then
	--	ZpetsIcon1Text:SetText("")
	--	else
	--	ZpetsIcon1Text:SetText(petIconDur1)
	--end
	
	WildImpTotem1 = 0
	WildImpTotem2 = 0
	WildImpTotem3 = 0
	WildImpTotem4 = 0
	
	PetTableDuration(imptimetable,impdurtable,13.2)
	PetTableDuration(deimptimetable,deimpdurtable,13.2)
	--tprint (imptimetable, indent)
	--tprint (impdurtable, indent)
	--tprint (deimpdurtable, indent)
	--if (PetTotemSummonCount(1,deimpdurtable,"Wild Imps")) > 0 then
	--	print("I Have: "..PetTotemSummonCount(1,deimpdurtable,"Wild Imps").." buffed Wild Imps")
	--	else
	--	print("I Have: "..PetTotemSummonCount(1,impdurtable,"Wild Imps").." unbuffed Wild Imps")
	--end
	----------------
	-- Pet Timers --
	----------------
	
		-- Totem 1 --
		ZpetsIcon1Text:SetPoint("CENTER",MyZpetCDFrame1,"CENTER",0,0)
		local haveTotem, tname, startTime, duration, icon = GetTotemInfo(1)
		local petIconDur1 = ((duration+1)-(GetTime()-startTime))
		if MyZpetCDFrame1Start ~= startTime then
			MyZpetCDFrame1Start = startTime
			MyZpetCDFrame1:SetCooldown(startTime, duration)
		end
		if petIconDur1 > 0 then
			ZpetsIcon1:Show()
			else
			ZpetsIcon1:Hide()
		end
		if petIconDur1 > 0 then
			petIconDur1 = math.floor(petIconDur1)
			else
			petIconDur1 = 0
		end		
		if petIconDur1 > 0 then
			ZpetsIcon1Text:SetText(petIconDur1)
			else
			ZpetsIcon1Text:SetText("")
		end		
		if tname == "Dreadstalkers" then
			zt2:SetTexture("Interface\\ICONS\\spell_warlock_calldreadstalkers")
			if dedreadcount > 0 then
				SetDesaturation(zt2, nil)
				else
				SetDesaturation(zt2, 1)
			end
			elseif tname == "Wild Imps" then
			zt2:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
			if (PetTotemSummonCount(1,deimptimetable,"Wild Imps")) > 0 then
			SetDesaturation(zt2, nil)
			--	print("I Have: "..PetTotemSummonCount(1,deimptimetable,"Wild Imps").." buffed Wild Imps")
			else
			SetDesaturation(zt2, 1)
			--	print("I Have: "..PetTotemSummonCount(1,imptimetable,"Wild Imps").." unbuffed Wild Imps")
			end
			elseif tname == "Darkglare" then
			zt2:SetTexture("Interface\\ICONS\\achievement_boss_durumu")
			if darkglarede > 0 then
				SetDesaturation(zt2, nil)
				else
				SetDesaturation(zt2, 1)
			end
		end
		
		-- Totem 2 --
		ZpetsIcon2Text:SetPoint("CENTER",MyZpetCDFrame2,"CENTER",0,0)
		local haveTotem, tname, startTime, duration, icon = GetTotemInfo(2)
		local petIconDur2 = ((duration+1)-(GetTime()-startTime))
		if MyZpetCDFrame2Start ~= startTime then
			MyZpetCDFrame2Start = startTime
			MyZpetCDFrame2:SetCooldown(startTime, duration)
		end
		if petIconDur2 > 0 then
			ZpetsIcon2:Show()
			else
			ZpetsIcon2:Hide()
		end
		if petIconDur2 > 0 then
			petIconDur2 = math.floor(petIconDur2)
			else
			petIconDur2 = 0
		end		
		if petIconDur2 > 0 then
			ZpetsIcon2Text:SetText(petIconDur2)
			else
			ZpetsIcon2Text:SetText("")
		end		
		if tname == "Dreadstalkers" then
			zt3:SetTexture("Interface\\ICONS\\spell_warlock_calldreadstalkers")
			if dedreadcount > 0 then
				SetDesaturation(zt3, nil)
				else
				SetDesaturation(zt3, 1)
			end
			elseif tname == "Wild Imps" then
			zt3:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
			if (PetTotemSummonCount(2,deimptimetable,"Wild Imps")) > 0 then
			SetDesaturation(zt3, nil)
			--	print("I Have: "..PetTotemSummonCount(2,deimptimetable,"Wild Imps").." buffed Wild Imps")
			else
			SetDesaturation(zt3, 1)
			--	print("I Have: "..PetTotemSummonCount(2,imptimetable,"Wild Imps").." unbuffed Wild Imps")
			end
			elseif tname == "Darkglare" then
			zt3:SetTexture("Interface\\ICONS\\achievement_boss_durumu")
			if darkglarede > 0 then
				SetDesaturation(zt3, nil)
				else
				SetDesaturation(zt3, 1)
			end
		end
		
		-- Totem 3 --
		ZpetsIcon3Text:SetPoint("CENTER",MyZpetCDFrame3,"CENTER",0,0)
		local haveTotem, tname, startTime, duration, icon = GetTotemInfo(3)
		local petIconDur3 = ((duration+1)-(GetTime()-startTime))
		if MyZpetCDFrame3Start ~= startTime then
			MyZpetCDFrame3Start = startTime
			MyZpetCDFrame3:SetCooldown(startTime, duration)
		end
		if petIconDur3 > 0 then
			ZpetsIcon3:Show()
			else
			ZpetsIcon3:Hide()
		end
		if petIconDur3 > 0 then
			petIconDur3 = math.floor(petIconDur3)
			else
			petIconDur3 = 0
		end		
		if petIconDur3 > 0 then
			ZpetsIcon3Text:SetText(petIconDur3)
			else
			ZpetsIcon3Text:SetText("")
		end		
		if tname == "Dreadstalkers" then
			zt4:SetTexture("Interface\\ICONS\\spell_warlock_calldreadstalkers")
			if dedreadcount > 0 then
				SetDesaturation(zt4, nil)
				else
				SetDesaturation(zt4, 1)
			end
			elseif tname == "Wild Imps" then
			zt4:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
			if (PetTotemSummonCount(3,deimptimetable,"Wild Imps")) > 0 then
			SetDesaturation(zt4, nil)
			--	print("I Have: "..PetTotemSummonCount(1,deimpdurtable,"Wild Imps").." buffed Wild Imps")
			else
			SetDesaturation(zt4, 1)
			--	print("I Have: "..PetTotemSummonCount(1,impdurtable,"Wild Imps").." unbuffed Wild Imps")
			end
			elseif tname == "Darkglare" then
			zt4:SetTexture("Interface\\ICONS\\achievement_boss_durumu")
			if darkglarede > 0 then
				SetDesaturation(zt4, nil)
				else
				SetDesaturation(zt4, 1)
			end
		end
		
		-- Totem 4 --
		ZpetsIcon4Text:SetPoint("CENTER",MyZpetCDFrame4,"CENTER",0,0)
		local haveTotem, tname, startTime, duration, icon = GetTotemInfo(4)
		local petIconDur4 = ((duration+1)-(GetTime()-startTime))
		if MyZpetCDFrame4Start ~= startTime then
			MyZpetCDFrame4Start = startTime
			MyZpetCDFrame4:SetCooldown(startTime, duration)
		end
		if petIconDur4 > 0 then
			ZpetsIcon4:Show()
			else
			ZpetsIcon4:Hide()
		end
		if petIconDur4 > 0 then
			petIconDur4 = math.floor(petIconDur4)
			else
			petIconDur4 = 0
		end		
		if petIconDur4 > 0 then
			ZpetsIcon4Text:SetText(petIconDur4)
			else
			ZpetsIcon4Text:SetText("")
		end		
		if tname == "Dreadstalkers" then
			zt5:SetTexture("Interface\\ICONS\\spell_warlock_calldreadstalkers")
			if dedreadcount > 0 then
				SetDesaturation(zt5, nil)
				else
				SetDesaturation(zt5, 1)
			end
			elseif tname == "Wild Imps" then
			zt5:SetTexture("Interface\\ICONS\\ability_warlock_impoweredimp")
			if (PetTotemSummonCount(4,deimptimetable,"Wild Imps")) > 0 then
			SetDesaturation(zt5, nil)
			--	print("I Have: "..PetTotemSummonCount(1,deimpdurtable,"Wild Imps").." buffed Wild Imps")
			else
			SetDesaturation(zt5, 1)
			--	print("I Have: "..PetTotemSummonCount(1,impdurtable,"Wild Imps").." unbuffed Wild Imps")
			end
			elseif tname == "Darkglare" then
			zt5:SetTexture("Interface\\ICONS\\achievement_boss_durumu")
			if darkglarede > 0 then
				SetDesaturation(zt5, nil)
				else
				SetDesaturation(zt5, 1)
			end
		end
		
		-- Doomguard Icon --
		ZpetsIcon5Text:SetPoint("CENTER",MyZpetCDFrame5,"CENTER",0,0)
		if doomguardduration > 0 or infernalduration > 0 then
			if doomguardduration > infernalduration then
				local displaytext = math.floor(doomguardduration)
				ZpetsIcon5Text:SetText(displaytext)
				else
				local displaytext = math.floor(infernalduration)
				ZpetsIcon5Text:SetText(displaytext)
			end			
			else
			ZpetsIcon5Text:SetText("")
		end	
		if doomguardduration > 0 or infernalduration > 0 then
			ZpetsIcon5:Show()
			else
			ZpetsIcon5:Hide()
		end
		if doomguardde > 0 or infernalde > 0 then
				SetDesaturation(zt6, nil)
				else
				SetDesaturation(zt6, 1)
		end
		
		-- Service --
		ZpetsIcon6Text:SetPoint("CENTER",MyZpetCDFrame6,"CENTER",0,0)
		if doomguardduration > 0 or infernalduration > 0 then
			ZpetsIcon6:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", -3, -42);
			else
			ZpetsIcon6:SetPoint("TOPLEFT", zPetsGUI, "TOPRIGHT", -3, -1);
		end
		if servicede > 0 then
				SetDesaturation(zt7, nil)
				else
				SetDesaturation(zt7, 1)
		end
		if serviceduration > 0 then
			ZpetsIcon6:Show()
			else
			ZpetsIcon6:Hide()
		end
		if serviceduration > 0 then
			
			local displaytext = math.floor(serviceduration)
			ZpetsIcon6Text:SetText(displaytext)
				
			else
			ZpetsIcon6Text:SetText("")
		end	
		
end


function MaintainCDProgress()
	local timesince = CallDreadStalker + 15
	if timesince < zpetscomptime then
		CallDreadStalker = 0
	end
	local timesince = SummonBeholder + 24
	if timesince < zpetscomptime then
		SummonBeholder = 0
	end
	local timesince = PetFelstorm + 45
	if timesince < zpetscomptime then
		PetFelstorm = 0
	end
	local timesince = CosumptionCD + 60
	if timesince < zpetscomptime then
		CosumptionCD = 0
	end
	local timesince = ServiceCD + 90
	if timesince < zpetscomptime then
		ServiceCD = 0
	end
end

function GetSpellCDProgress(SpellName,MaxDuration,CDVar)
    local maxduration=MaxDuration
    local current = 0
	local start = 0
	local duration = 0
    local start, duration, enabled = GetSpellCooldown(SpellName);
    local cooldown = (start + duration - GetTime())
    if start > 0 and duration > 0 then
        current = cooldown
    else
        current = 0
    end
    
    local currentamount = maxduration - current
    local results = math.floor((currentamount/maxduration)*100)
	local testedvar = CDVar
	if testedvar > 0 then
    return (results)
	else 
	return (100)
	end
end

function ImplosionValue()
	local implosioncoefficient = 1.6
	local implosiondamage = (implosioncoefficient*zpetsspellDmg*zpetsversmod)
	totalvalueofimplosion=(math.floor(implosiondamage*totalimpcount))
end

function CooldownSummons()
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Doomguard" and zpetssourceGUID==playerguid) then
			doomguardspawned=zpetscomptime
			doomguarddeapplied=0
			doomguardappliedduration = 12
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Infernal" and zpetssourceGUID==playerguid) then
			infernalspawned=zpetscomptime
			infernaldeapplied=0
			infernalappliedduration = 12
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Felguard" and zpetssourceGUID==playerguid) then
			servicespawned=zpetscomptime
			servicedeapplied=0
			serviceappliedduration = 12
			servicehealthmod=zpetsfelguardmax
			servicename="Felguard"
		end		
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Imp" and zpetssourceGUID==playerguid) then
			servicespawned=zpetscomptime
			servicedeapplied=0
			serviceappliedduration = 12
			servicehealthmod=zpetsimpmax
			servicename="Imp"
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Voidwalker" and zpetssourceGUID==playerguid) then
			servicespawned=zpetscomptime
			servicedeapplied=0
			serviceappliedduration = 12
			servicehealthmod=zpetsvoidwalkermax
			servicename="Voidwalker"
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Succubus" and zpetssourceGUID==playerguid) then
			servicespawned=zpetscomptime
			servicedeapplied=0
			serviceappliedduration = 12
			servicehealthmod=zpetssuccubusmax
			servicename="Succubus"
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Felhunter" and zpetssourceGUID==playerguid) then
			servicespawned=zpetscomptime
			servicedeapplied=0
			serviceappliedduration = 12
			servicehealthmod=zpetsfelhuntermax
			servicename="Felhunter"
		end
		if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName=="Darkglare" and zpetssourceGUID==playerguid) then
			darkglarespawned=zpetscomptime
			darkglaredeapplied=0
			darkglareappliedduration = 12
			darkglarehealthmod=zpetsfelhuntermax
		end
end

function MaintainCooldowns()
	if(doomguardspawned+26<zpetscomptime) then
		local doomguardspawned = 0
		doomguardcount = 0
		else
		doomguardcount = 1
	end
	if(doomguarddeapplied+doomguardappliedduration<zpetscomptime) then
		doomguarddeapplied = 0
		doomguardde = 0
		doomguardappliedduration = 12
	end
	if(doomguardspawned+26>zpetscomptime) then
		durationspent = zpetscomptime-doomguardspawned
		duration = 25-durationspent
		doomguardduration=duration
	end
	if doomguardduration < 0 then
		doomguardduration = 0
	end
	if(doomguarddeapplied+doomguardappliedduration>zpetscomptime) then
		durationspent = zpetscomptime-doomguarddeapplied
		duration = doomguardappliedduration-durationspent
		doomguarddeduration=duration
	end
	if doomguarddeduration < 0 then
		doomguarddeduration = 0
	end
	if doomguardde == 0 then
		doomguarddeduration = 0
	end
	if doomguarddeduration > doomguardduration then
		doomguarddeduration = doomguardduration
	end
	if doomguardcount == 0 then
		doomguardde = 0
	end
	if(infernalspawned+26<zpetscomptime) then
		local infernalspawned = 0
		infernalcount = 0
		else
		infernalcount = 1
	end
	if(infernaldeapplied+infernalappliedduration<zpetscomptime) then
		infernaldeapplied = 0
		infernalde = 0
		infernalappliedduration = 12
	end
	if(infernalspawned+26>zpetscomptime) then
		durationspent = zpetscomptime-infernalspawned
		duration = 25-durationspent
		infernalduration=duration
	end
	if infernalduration < 0 then
		infernalduration = 0
	end
	if(infernaldeapplied+infernalappliedduration>zpetscomptime) then
		durationspent = zpetscomptime-infernaldeapplied
		duration = infernalappliedduration-durationspent
		infernaldeduration=duration
	end
	if infernaldeduration < 0 then
		infernaldeduration = 0
	end
	if infernalde == 0 then
		infernaldeduration = 0
	end
	if infernaldeduration > infernalduration then
		infernaldeduration = infernalduration
	end
	if infernalcount == 0 then
		infernalde = 0
	end
	if(servicespawned+26<zpetscomptime) then
		local servicespawned = 0
		servicecount = 0
		else
		servicecount = 1
	end
	if(servicedeapplied+serviceappliedduration<zpetscomptime) then
		servicedeapplied = 0
		servicede = 0
		serviceappliedduration = 12
	end
	if(servicespawned+26>zpetscomptime) then
		durationspent = zpetscomptime-servicespawned
		duration = 25-durationspent
		serviceduration=duration
	end
	if serviceduration < 0 then
		serviceduration = 0
	end
	if(servicedeapplied+serviceappliedduration>zpetscomptime) then
		durationspent = zpetscomptime-servicedeapplied
		duration = serviceappliedduration-durationspent
		servicededuration=duration
	end
	if servicededuration < 0 then
		servicededuration = 0
	end
	if servicede == 0 then
		servicededuration = 0
	end
	if servicededuration > serviceduration then
		servicededuration = serviceduration
	end
	if servicecount == 0 then
		servicede = 0
	end
	if(darkglarespawned+13.2<zpetscomptime) then
		local darkglarespawned = 0
		darkglarecount = 0
		else
		darkglarecount = 1
	end
	if(darkglaredeapplied+darkglareappliedduration<zpetscomptime) then
		darkglaredeapplied = 0
		darkglarede = 0
		darkglareappliedduration = 12
	end
	if(darkglarespawned+13.2>zpetscomptime) then
		durationspent = zpetscomptime-darkglarespawned
		duration = 12-durationspent
		darkglareduration=duration
	end
	if darkglareduration < 0 then
		darkglareduration = 0
	end
	if(darkglaredeapplied+darkglareappliedduration>zpetscomptime) then
		durationspent = zpetscomptime-darkglaredeapplied
		duration = darkglareappliedduration-durationspent
		darkglarededuration=duration
	end
	if darkglarededuration < 0 then
		darkglarededuration = 0
	end
	if darkglarede == 0 then
		darkglarededuration = 0
	end
	if darkglarededuration > darkglareduration then
		darkglarededuration = darkglareduration
	end
	if darkglarecount == 0 then
		darkglarede = 0
	end
end

function ConsuptionValue()
	zpetstotaldoomguardhealth=0
	zpetstotalinfernalhealth=0
	zpetstotalservicehealth=0
	local zpetsdemod = 1.6
	local thalkielshealthcost = .1
	local zpetsplayermax = UnitHealthMax("player")
	local zpetspetmax = UnitHealthMax("pet")
	local zpetswildimpmax = .15
	local zpetsdreadmax = .4
	--local zpetsbeholdermax = .4
	local zpetsdoomguardmax = .4
	local zpetsinfernalmax = .6
	local zpetsfelguardmax = .5
	local zpetsfelhuntermax = .5
	local zpetsimpmax = .3
	local zpetssuccubusmax = .4
	local zpetsvoidwalkermax = .5
	local darkglarehealthmod = .4
	local servicehealthmod=zpetsfelguardmax
	local zpetsdreadactual = zpetsdreadmax*zpetsplayermax
	local zpetswildimpactual = zpetswildimpmax*zpetsplayermax
	--local zpetsbeholderactual = zpetsbeholdermax*zpetsplayermax
	local zpetsdoomguardactual = zpetsdoomguardmax*zpetsplayermax
	local zpetsinfernalactual = zpetsinfernalmax*zpetsplayermax
	local zpetsserviceactual = servicehealthmod*zpetsplayermax	
	local zpetsdarkglareactual = darkglarehealthmod*zpetsplayermax	
	local totalwildimphealth=zpetswildimpactual*impcount
	local totaldreadhealth=zpetsdreadactual*dreadcount
	--local totalbeholderhealth=zpetsbeholderactual*beholdercount	
	local totaldewildimphealth=zpetswildimpactual*deimpcount*zpetsdemod
	local totaldedreadhealth=zpetsdreadactual*dedreadcount*zpetsdemod
	--local totaldebeholderhealth=zpetsbeholderactual*debeholdercount*zpetsdemod	
	if doomguardde > 0 then
			zpetstotaldoomguardhealth=(doomguardcount*zpetsdoomguardactual*zpetsdemod)
		else
			zpetstotaldoomguardhealth=(doomguardcount*zpetsdoomguardactual)
	end
	if infernalde > 0 then
			zpetstotalinfernalhealth=(infernalcount*zpetsinfernalactual*zpetsdemod)
		else
			zpetstotalinfernalhealth=(infernalcount*zpetsinfernalactual)
	end
	if servicede > 0 then
			zpetstotalservicehealth=(servicecount*zpetsserviceactual*zpetsdemod)
		else
			zpetstotalservicehealth=(servicecount*zpetsserviceactual)
	end
	if darkglarede > 0 then
			zpetstotaldarkglarehealth=(darkglarecount*zpetsdarkglareactual*zpetsdemod)
		else
			zpetstotaldarkglarehealth=(darkglarecount*zpetsdarkglareactual)
	end
	local totalpethealthvalue=zpetspetmax+totalwildimphealth+totaldreadhealth+totaldewildimphealth+totaldedreadhealth+zpetstotaldoomguardhealth+zpetstotalinfernalhealth+zpetstotalservicehealth+zpetstotaldarkglarehealth--+totaldebeholderhealth
	local damagetopets=totalpethealthvalue*thalkielshealthcost
	local damagepostvers=damagetopets*zpetsversmod2	
	thalkielstotalvalue=(math.floor((damagepostvers*zpetsversmod)))
end

function HitCount(tab,spellName,pet)
	if pet == true then
		usedguid = zpetsguid
		else
		usedguid = playerguid
	end
	if (zpetscombatevent=="SPELL_DAMAGE" and zpetsspellName==spellName and zpetssourceGUID==usedguid) then
		tab[zpetsdestGUID]=zpetscomptime		
	end
end

function ClearHitCount(tab,period,haste)
	if haste == true then
		for i,v in pairs(tab) do
			local hastedperiod = (period/zpetshastemod)
			if(v+zpetshastemod<zpetscomptime) then
				tab[i]=nil
			end
		end
	else
		for i,v in pairs(tab) do
			if(v+period<zpetscomptime) then
				tab[i]=nil
			end
		end
	end
end

function CountPets()
	impcount = entrysum(imptimetable)
	deimpcount = entrysum(deimptimetable)
	totalimpcount = impcount+deimpcount
	
	dreadcount = entrysum(dreadtimetable)
	dedreadcount = entrysum(dedreadtimetable)
	totaldreadcount = dreadcount+dedreadcount	
	
	--beholdercount = entrysum(beholdertimetable)
	--debeholdercount = entrysum(debeholdertimetable)
	--totalbeholdercount = debholdercount + beholdercount
	
	petcount = totalimpcount+totaldreadcount+doomguardcount+servicecount+infernalcount+darkglarecount--+totalbeholdercount
	petsneedde = impcount+dreadcount--+beholdercount
	if doomguardcount > 0 and doomguardde == 0 then
		petsneedde = petsneedde + 1
	end
	if servicecount > 0 and servicede == 0 then
		petsneedde = petsneedde + 1
	end
	if infernalcount > 0 and infernalde == 0 then
		petsneedde = petsneedde + 1
	end	
	if darkglarecount > 0 and darkglarede == 0 then
		petsneedde = petsneedde + 1
	end	
end

function CountImpCasts()
	impcastremains = GetCastsRemaining(imptimetable,impcasttime,13.2,2,false)
	deimpcastremains = GetCastsRemaining(deimptimetable,deimpcasttime,13.2,2,true)
end

function DemonicEmpowerment()
	if (zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceGUID==playerguid and zpetsspellName=="Demonic Empowerment") then
		merge(imptimetable,deimptimetable)
		deimptimetable=clone(imptimetable)
		imptimetable=clone(emptytimetable)		
		merge(impcasttime,deimpcasttime)
		deimpcasttime=clone(impcasttime)
		impcasttime=clone(emptytimetable)		
		merge(dreadtimetable,dedreadtimetable)
		dedreadtimetable=clone(dreadtimetable)
		dreadtimetable=clone(emptytimetable)		
		--merge(beholdertimetable,debeholdertimetable)
		--debeholdertimetable=clone(beholdertimetable)
		--beholdertimetable=clone(emptytimetable)		
		if doomguardduration > 0 then
		doomguardde = 1
		end
		if doomguarddeduration == 0 then
			doomguarddeapplied = zpetscomptime
		end
		if doomguarddeduration > 3.6 then
			doomguardappliedduration = 15.6
			doomguarddeapplied = zpetscomptime
		end
		if doomguarddeduration < 3.6 and doomguarddeduration > 0 then
			doomguardappliedduration = 12+doomguarddeduration
			doomguarddeapplied = zpetscomptime
		end
		if infernalduration > 0 then
		infernalde = 1
		end
		if infernaldeduration == 0 then
			infernaldeapplied = zpetscomptime
		end
		if infernaldeduration > 3.6 then
			infernalappliedduration = 15.6
			infernaldeapplied = zpetscomptime
		end
		if infernaldeduration < 3.6 and infernaldeduration > 0 then
			infernalappliedduration = 12+infernaldeduration
			infernaldeapplied = zpetscomptime
		end
		if serviceduration > 0 then
		servicede = 1
		end
		if servicededuration == 0 then
			servicedeapplied = zpetscomptime
		end
		if servicededuration > 3.6 then
			serviceappliedduration = 15.6
			servicedeapplied = zpetscomptime
		end
		if servicededuration < 3.6 and servicededuration > 0 then
			serviceappliedduration = 12+servicededuration
			servicedeapplied = zpetscomptime
		end
		if darkglareduration > 0 then
		darkglarede = 1
		end
		if darkglarededuration == 0 then
			darkglaredeapplied = zpetscomptime
		end
		if darkglarededuration > 3.6 then
			darkglareappliedduration = 15.6
			darkglaredeapplied = zpetscomptime
		end
		if darkglarededuration < 3.6 and darkglarededuration > 0 then
			darkglareappliedduration = 12+darkglarededuration
			darkglaredeapplied = zpetscomptime
		end
	end
end

function TimeOut(tab, dur) --Time out units in the table that have passed their duration
	for k,v in pairs(tab) do
		if(v+dur<zpetscomptime) then
			tab[k]=nil
		end
	end
end

function SummonTable(tab,unitname) --Fills the given table with the given units summon time
	if (zpetscombatevent=="SPELL_SUMMON" and zpetsdestName==unitname and zpetssourceGUID==playerguid) then
		tab[zpetsdestGUID]=zpetscomptime
	end
end

function DeathTable(tab,unitname) --Removes units from the given table if they are killed or destroyed
	if(zpetscombatevent=="UNIT_DIED") then
		for i,v in pairs(tab) do
			if(zpetsdestGUID==i) then
				tab[i]=nil
			end
		end
	end
	if(zpetscombatevent=="SPELL_INSTAKILL") then
		for i,v in pairs(tab) do
			if(zpetsdestGUID==i) then
				tab[i]=nil
			end
		end
	end
end

function PetCastTable(tab,unitname,tab2) --Adds cast start time of unitname to tab as long as unit exists in tab2
	if(zpetscombatevent=="SPELL_CAST_SUCCESS" and zpetssourceName==unitname) then
		for i,v in pairs(tab2) do
			if(zpetssourceGUID==i) then
				tab[i]=zpetscomptime	
			end
		end
	 end
end

function GetCastsRemaining(tab,tab2,petduration,casttime,de) --tab = spawn table, tab2= caststart table, petduration = petsmaxduration, casttime = spells default cast time, de = true|false if empowered
	local realcasttime = 0
	local totalcastsremaining = 0	
	if de == true then
		realcasttime = casttime/zpetsdehastemod
		else
		realcasttime = casttime/zpetshastemod
	end	
	for k, v in pairs(tab) do
		local casttimeleft = 0
		local creatureid = k
		local durationremaining = petduration-(zpetscomptime-v)
		local timespentcast = GetTimeSpentCasting(creatureid,tab2)
		if timespentcast == nil then
			timespentcast = 0
		end
		if timespentcast > 0 then
			local casttimeleft = realcasttime-timespentcast
		end
		local usableduration =  durationremaining-timespentcast
		local castsremaining = usableduration/realcasttime		
		if casttimeleft ~= 0 and casttimeleft < durationremaining then
			local castsremaining = castsremaining + 1
		end
		local castsremaining = math.floor(castsremaining)
		totalcastsremaining = totalcastsremaining+castsremaining	
	end
	return(totalcastsremaining)
end

function PetTableDuration(tab,tab2,petduration)
	for k, v in pairs(tab) do
		local newshit = k
		local durationremaining = petduration-(zpetscomptime-v)
		--print(durationremaining)
		tab2[newshit]=durationremaining
	end
	
	for k, v in pairs(tab2) do
		local keycheck = k
		local testvar = 0
		for k, v in pairs(tab) do
			if k == keycheck then
				testvar = testvar + 1
				else
			end	
		end
		if testvar == 0 then
			tab2[keycheck]=nil
		end
	end
end


function PetTotemSummonCount(TotemNumber,tab,PetType)
	local petcount = 0
	local depetcount = 0
	local totemStart = 0
	local haveTotem, tname, startTime, duration, icon = GetTotemInfo(TotemNumber)
		if tname == PetType then
			totemStart = startTime
		end
		
	for k, v in pairs(tab) do
		local teststart = v
		--print(teststart.." , "..totemStart)
		if (teststart < totemStart + 1) and (teststart > totemStart - 1) then
			petcount = petcount+1
			 
		end
	end	
	return(petcount)
end



function GetTimeSpentCasting(creatureid,tab) --Find out how much creatures in table have spent casting since cast start
	for i,v in pairs(tab) do					
		if creatureid == i then
			local timespentcast = zpetscomptime - v
			return(timespentcast)
		end			
	end
end

function ValueWildImps() --Get a total damage value of all current Wild Imps
	local wildimpsscaler = 1
	local felfireballcoefficient = 0.18
	local ifdamagemod = ((infernalfurnace*zpetsartifactpower1)+1)
	local versmod = (zpetsversmod)
	--local versmod = 1
	local felfireballdamage = (zpetsspellDmg * felfireballcoefficient* wildimpsscaler*versmod*ifdamagemod)
	local felfireballdamagede = (zpetsspellDmg * felfireballcoefficient * wildimpsscaler*versmod*ifdamagemod*zpetsmasterymod)
	wildimpvalue = ((impcastremains*felfireballdamage)+(deimpcastremains*felfireballdamagede))	
end

function clone (t) -- deep-copy a table
    if type(t) ~= "table" then return t end
    local meta = getmetatable(t)
    local target = {}
    for k, v in pairs(t) do
        if type(v) == "table" then
            target[k] = clone(v)
        else
            target[k] = v
        end
    end
    setmetatable(target, meta)
    return target
end

function merge(a, b)
    if type(a) == 'table' and type(b) == 'table' then
        for k,v in pairs(b) do if type(v)=='table' and type(a[k] or false)=='table' then merge(a[k],v) else a[k]=v end end
    end
    return a
end

function sum(t) --Get the total value of entries in a table
    local sum = 0
    for k,v in pairs(t) do
        sum = sum + v
    end
    return sum
end

function entrysum(t) --Get the total number of entries in a table
    local sum = 0
    for k,v in pairs(t) do
        sum = sum + 1
    end
    return sum
end

function SummonersProwess()
	if zpetsartifactpower2 == 0 then
	SPMod = 0
	elseif zpetsartifactpower2 == 1 then
	SPMod = 3
	elseif zpetsartifactpower2 == 2 then
	SPMod = 6
	elseif zpetsartifactpower2 == 3 then
	SPMod = 10
	elseif zpetsartifactpower2 == 4 then
	SPMod = 13
	elseif zpetsartifactpower2 == 5 then
	SPMod = 16
	elseif zpetsartifactpower2 == 6 then
	SPMod = 20
	end
end

function DemoClassCreate()
	zPetBackground:Show()

	-- Call Dreadstalkers --
	MyZpetBar1:Show()
	MyZpetBar1:SetMinMaxValues(0, 100)
	MyZpetBar1:SetWidth(106)
	MyZpetBar1:SetHeight(10)
	MyZpetBar1:SetStatusBarColor(.36,.43,.26)
	
	-- Summon Darkglare / Felstorm --
	MyZpetBar2:Show()
	MyZpetBar2:SetMinMaxValues(0, 100)
	MyZpetBar2:SetWidth(106)
	MyZpetBar2:SetHeight(10)
	if IsPlayerSpell(205180) then -- Setup Bar 2 Based on Summon Observer talent
		MyZpetBar2:SetStatusBarColor(.23,.32,.41)
		else
		MyZpetBar2:SetStatusBarColor(.52,.41,.34)
	end
	
	-- Thal'kiel's Consumption --
	MyZpetBar3:Show()
	MyZpetBar3:SetMinMaxValues(0, 100)
	MyZpetBar3:SetHeight(10)
	if IsPlayerSpell(111898) then
		MyZpetBar3:SetWidth(106)
		else
		MyZpetBar3:SetWidth(214)
	end
	MyZpetBar3:SetStatusBarColor(.29,.25,.51)
	
	-- Grimoire: Service --
	if IsPlayerSpell(111898) then
		MyZpetBar4:Show()
		else
		MyZpetBar4:Hide()
	end
	MyZpetBar4:SetMinMaxValues(0, 100)
	MyZpetBar4:SetHeight(10)
	MyZpetBar4:SetWidth(106)
	MyZpetBar4:SetStatusBarColor(.29,.25,.51)
	
	-- Soul Shards --
	MyZpetBar5:SetMinMaxValues(0, 100)
	MyZpetBar5:SetHeight(10)
	MyZpetBar5:SetWidth(41.2)
	MyZpetBar5:SetStatusBarColor(.90,0,1)
	MyZpetBar6:SetMinMaxValues(0, 100)
	MyZpetBar6:SetHeight(10)
	MyZpetBar6:SetWidth(41.2)
	MyZpetBar6:SetStatusBarColor(.90,0,1)
	MyZpetBar7:SetMinMaxValues(0, 100)
	MyZpetBar7:SetHeight(10)
	MyZpetBar7:SetWidth(41.2)
	MyZpetBar7:SetStatusBarColor(.90,0,1)
	MyZpetBar8:SetMinMaxValues(0, 100)
	MyZpetBar8:SetHeight(10)
	MyZpetBar8:SetWidth(41.2)
	MyZpetBar8:SetStatusBarColor(.90,0,1)
	MyZpetBar9:SetMinMaxValues(0, 100)
	MyZpetBar9:SetHeight(10)
	MyZpetBar9:SetWidth(41.2)
	MyZpetBar9:SetStatusBarColor(.90,0,1)
	
	-- Shadowflame --
	if IsPlayerSpell(205181) then
		MyZpetBar10:SetMinMaxValues(0, 100)
		MyZpetBar10:SetHeight(10)
		MyZpetBar10:SetWidth(106)
		MyZpetBar10:SetStatusBarColor(.54,.31,.53)
		MyZpetBar10:Show()
		MyZpetBar11:SetMinMaxValues(0, 100)
		MyZpetBar11:SetHeight(10)
		MyZpetBar11:SetWidth(106)
		MyZpetBar11:SetStatusBarColor(.54,.31,.53)
		MyZpetBar11:Show()
		else
		MyZpetBar10:Hide()
		MyZpetBar11:Hide()
	end
	
	-- Setup correct Background Size based on talents --
	if IsPlayerSpell(205181) then
		zPetBackground:SetHeight(50)
		else
		zPetBackground:SetHeight(38)
	end
end

function HideFrames()
	zPetBackground:Hide()
	MyZpetBar1:Hide()
	MyZpetBar2:Hide()
	MyZpetBar3:Hide()
	MyZpetBar4:Hide()
	MyZpetBar5:Hide()
	MyZpetBar6:Hide()
	MyZpetBar7:Hide()
	MyZpetBar8:Hide()
	MyZpetBar9:Hide()
	MyZpetBar10:Hide()
	MyZpetBar11:Hide()
	ZpetsIcon1:Hide()
	ZpetsIcon2:Hide()
	ZpetsIcon3:Hide()
	ZpetsIcon4:Hide()
	ZpetsIcon5:Hide()
	ZpetsIcon6:Hide()
	
	
end

function GetSpec()
	local currentSpec = GetSpecialization()
	local localizedClass, englishClass, classIndex = UnitClass("player");
	if classIndex == 9 and currentSpec == 1 then
		zpetspec = "Affliction"
		elseif classIndex == 9 and currentSpec == 2 then
		zpetspec = "Demonology"
		elseif classIndex == 9 and currentSpec == 3 then
		zpetspec = "Destruction"
		else
		zpetspec = "NA"
	end
	end
function tprint (tbl, indent)
if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      print(formatting .. tostring(v))      
    else
      print(formatting .. v)
    end
  end
end

function SetDesaturation(texture, desaturation)
	local shaderSupported = texture:SetDesaturated(desaturation);
	if ( not shaderSupported ) then
		if ( desaturation ) then
			texture:SetVertexColor(0.5, 0.5, 0.5);
		else
			texture:SetVertexColor(1.0, 1.0, 1.0);
		end
		
	end
end


